> For the complete documentation index, see [llms.txt](https://docs.blockxnet.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.blockxnet.com/protocol-developers/modules/evm/events.md).

# Events

The `x/evm` module emits the Cosmos SDK events after a state execution. The EVM module emits events of the relevant transaction fields, as well as the transaction logs (ethereum events).

### MsgEthereumTx <a href="#msgethereumtx" id="msgethereumtx"></a>

| Type         | Attribute Key      | Attribute Value         |
| ------------ | ------------------ | ----------------------- |
| ethereum\_tx | `"amount"`         | `{amount}`              |
| ethereum\_tx | `"recipient"`      | `{hex_address}`         |
| ethereum\_tx | `"contract"`       | `{hex_address}`         |
| ethereum\_tx | `"txHash"`         | `{tendermint_hex_hash}` |
| ethereum\_tx | `"ethereumTxHash"` | `{hex_hash}`            |
| ethereum\_tx | `"txIndex"`        | `{tx_index}`            |
| ethereum\_tx | `"txGasUsed"`      | `{gas_used}`            |
| tx\_log      | `"txLog"`          | `{tx_log}`              |
| message      | `"sender"`         | `{eth_address}`         |
| message      | `"action"`         | `"ethereum"`            |
| message      | `"module"`         | `"evm"`                 |

Additionally, the EVM module emits an event during `EndBlock` for the filter query block bloom.

### ABCI <a href="#abci" id="abci"></a>

| Type         | Attribute Key | Attribute Value      |
| ------------ | ------------- | -------------------- |
| block\_bloom | `"bloom"`     | `string(bloomBytes)` |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.blockxnet.com/protocol-developers/modules/evm/events.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
